import axios from "axios"
import {requestUtil} from "./requestUtil";
export const getCurrentCity=()=>{
    const localCity = JSON.parse(localStorage.getItem('local_city'))
    if(!localCity){
        return new Promise((resolve,reject)=>{
            const curCity = new window.BMapGL.LocalCity()
            curCity.get(async res=>{
                try{
                    const result = await axios.get('http://localhost:8080/area/info?name=${res.name}')
                    localStorage.setItem('local_city',JSON.stringify(result.data.body))
                    resolve(result.data.body)
                }catch(e){
                    reject(e)
                }

            })
        })

    }
    // return new Promise((resolve)=>{
    //     return resolve(localCity)
    // })
    return Promise.resolve(localCity)
}

export const getTaskList=  (pageNumber) => {
    let request = encodeURI('{"pageSize":20,"pageNumber":'+pageNumber+',"data":[{"name":"tree","value":"TRUE","operateType":"TREE-FILTER"},{"name":"state","value":"8,9","operateType":"IN"}]}')
    return requestUtil.get('/todo-server/search/task_message_tree?search='+request);
}
// 根据pid获取未完成的任务
export const getTaskByPid = (pid) => {
    return requestUtil.get('/todo-server/search/task_message_tree?search=%7B%22pageSize%22%3A1000%2C%22pageNumber%22%3A1%2C%22data%22%3A%5B%7B%22name%22%3A%22pid%22%2C%22value%22%3A%22'+pid+'%22%2C%22operateType%22%3A%22%3D%22%7D%5D%7D');
}
export const addTask = async (entity) => {
    // 使用 Axios 发送 POST 请求添加数据
    const response = await requestUtil.post('/todo-server' + '/task', entity);
    // 从响应中提取数据并返回
    return response.data;
}